unit TEECHART_TST;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, math,
  vcltee.TeeProcs, vcltee.teEngine, vcltee.Chart, vcltee.Series, VclTee.TeeGDIPlus, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series3: TPointSeries;
    Series2: TLineSeries;
    Series1: TLineSeries;
    Series4: TPointSeries;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }

    AllData           : Array[1..100] of double;

    zzLo,
    zzHi,
    Index             : Integer;

    vINS,                                                                       // 2013-01-14
    vMTHCL,                                                                     // 2013-01-14
    vMETH,                                                                      // 2014-08-07
    vQCSet,
    vQCEfdt,
    vQCId,
    vqcidttl,                                                                   //2014-07-31
    vRC,vRName,
    vRAbrv            : String;
    TQCSPEC1,
    TQCSPEC2,
    TQCSPEC3,
    TQC_Cmt,
    TNewCmt           : TStringList;
    FPrint,                                                                     // 2012-11-07
    vFirst,vOK,
    vDfltTar,
    XSHNODATA,                                                                   //2012-04-03
    vChng             : Boolean;

    GHi,GLo           : Real;
    Hi,Lo             : Real;
    PageCnt,                                                                    // 2012-11-07
    TCnt,SCnt         : Integer;
    Tot,Mean          : Real;
    Std,Vari          : Real;
    Rng               : Real;
    TMean,TSDev,TVar  : Real;
    StdA              : Array of Double;

    MHi,MLo           : Real;
    MTCnt,MSCnt       : Integer;
    MTot,MMean        : Real;
    MStd,MVari        : Real;
    MRng              : Real;
    MStdA             : Array of Double;

    YHi,YLo           : Real;
    YTCnt,YSCnt       : Integer;
    YTot,YMean        : Real;
    YStd,YVari        : Real;
    YRng              : Real;
    YStdA             : Array of Double;

    Procedure Get_Graph(Index:Integer);
    procedure get_axis;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Procedure TFORM1.Get_Graph(Index:Integer);

Var

  Sel,
  RDT,vLegend,
  vQCSpec,
  vQRCOpt,
  vCmt,
  vFlgRsn,                                                                      // 2011-12-30
  Sdt,Edt          : String;
  xRslt            : Variant;
  I,J,Cnt          : Integer;                                                   // 2013-03-06
  Diff,Fnd         : Boolean;                                                   // 2013-03-06
  Last             : String;                                                    // 2013-03-06
  SpecLst          : TStringList;                                               // 2013-03-06

Begin

  Chart1.Visible := True;

  Screen.Cursor := crHourGlass;

  Chart1.SeriesList[0].Clear;
  Chart1.SeriesList[1].Clear;
  Chart1.SeriesList[2].Clear;
  Chart1.SeriesList[3].Clear;
  SetLength(StdA,0);

  zzLo  := -1;
  zzHi  := 100;
  gLo   := 9999999;
  gHi   := 0;
  Lo    := 9999999;
  Hi    := -999999;   //2016-04-20  WAS 0
  SCnt  := 0;
  TCnt  := 0;
  Tot   := 0;
  Rng   := 0;
  Std   := 0;
  Vari  := 0;
  Mean  := 0;

  SpecLst := TStringList.Create;
  SpecLst.Clear;

  For I := 0 To 100 Do
    begin

      xRslt   := AllData[I];

      Chart1.SeriesList[0].AddNull(vLegend);
          Chart1.SeriesList[1].AddXY(TCnt,xRslt,vLegend);
          If ( xRslt < GLo ) Then GLo := xRslt;
          If ( xRslt > GHi ) Then GHi := xRslt;
          If vQRCOpt <> '3' Then
            begin
              If ( xRslt < Lo ) Then Lo := xRslt;
              If ( xRslt > Hi ) Then Hi := xRslt;
              Tot := Tot + xRslt;
              SetLength(StdA,SCnt+1);
              StdA[SCnt] := xRslt;
              SCnt := SCnt + 1;
            end;

      TCnt  := TCnt + 1;
      Chart1.Page := Chart1.NumPages;
    end;

   TMean := 0;
   TSDev := 0;
   TVar  := 0;

  Chart1.MaxPointsPerPage := 10;

  If ( SCnt > 2 ) Then
    begin
      Try                                                                                // 2012-02-03  begin
        Std  := StdDev(StdA);
        Vari := Variance(StdA);
      Except
        Std  := 0;
        Vari := 0;
      End;                                                                               // 2012-02-03  end
      Mean := (Tot-xRslt) / (SCnt-1);
    end;

  If SCnt>0 Then SetLength(StdA,SCnt-1);

  Rng  := Hi - Lo;

//--------------

  MLo    := 9999999;
  MHi    := 0;
  MSCnt  := 0;
  MTCnt  := 0;
  MTot   := 0;
  MRng   := 0;
  MStd   := 0;
  MVari  := 0;
  MMean  := 0;

  For I := 0 To 100 Do
    begin
      xRslt   := AllData[i];

              If ( xRslt < MLo ) Then MLo := xRslt;
              If ( xRslt > MHi ) Then MHi := xRslt;
              MTot := MTot + xRslt;
              SetLength(MStdA,MSCnt+1);
              MStdA[MSCnt] := xRslt;
              MSCnt := MSCnt + 1;
      MTCnt  := MTCnt + 1;
    end;
  If MSCnt > 1 Then
    SetLength(MStdA,MSCnt-1);
  If ( MSCnt > 2 ) Then
    begin
      MVari := Variance(MStdA);
      MMean := (MTot-xRslt) / (MSCnt-1);
      Diff  := False;                                                           // 2013-03-06  begin
      Last  := '';
      For j := 0 to MSCnt-1 Do
        begin
          If ( Last <> '' ) And ( Last <> VartoStr(MStdA[j]) ) Then Diff := True;
          Last := VarToStr(MStdA[j]);
        end;
      If Diff Then MStd := StdDev(MStdA)
      Else MStd := 0;                                                           // 2013-03-06  end
    end;
  MRng  := MHi - MLo;

//--------------

  YLo    := 9999999;
  YHi    := 0;
  YSCnt  := 0;
  YTCnt  := 0;
  YTot   := 0;
  YRng   := 0;
  YStd   := 0;
  YVari  := 0;
  YMean  := 0;

  For I := 0 To 100 Do
    begin
      xRslt   := AllData[I];

              If ( xRslt < YLo ) Then YLo := xRslt;
              If ( xRslt > YHi ) Then YHi := xRslt;
              YTot := YTot + xRslt;
              SetLength(YStdA,YSCnt+1);
              YStdA[YSCnt] := xRslt;
              YSCnt := YSCnt + 1;
      YTCnt  := YTCnt + 1;
    end;
  If YSCnt > 1 Then
    SetLength(YStdA,YSCnt-1);
  If ( YSCnt > 2 ) Then
    begin
      YVari := Variance(YStdA);
      YMean := (YTot-xRslt) / (YSCnt-1);
      Diff  := False;                                                           // 2013-03-06  begin
      Last  := '';
      For j := 0 to YSCnt-1 Do
        begin
          If ( Last <> '' ) And ( Last <> VartoStr(YStdA[j]) ) Then Diff := True;
          Last := VarToStr(YStdA[j]);
        end;
      If Diff Then YStd := StdDev(YStdA)
      Else YStd := 0;                                                           // 2013-03-06  end
    end;
  YRng  := YHi - YLo;

//--------------

  Get_Axis;

  Chart1.MaxPointsPerPage := 10;

  Screen.Cursor := crDefault;
END;

procedure TForm1.FormCreate(Sender: TObject);
var
 i  : integer;
begin

  for I := 0 to 100 do
    begin
      alldata[i]:=Random;
    end;

    get_graph(0);
    get_axis;
end;

procedure TForm1.get_axis;
VAR
  I            : Integer;
  TY,
  X            : Real;
  lMean,lStd   : Real;

begin
  Screen.Cursor := crHourGlass;

  lMean := 0;
  lStd  := 0;

  If Mean > 0 Then
    begin
      lMean := Mean;
      lStd  := Std;
    end;

  Chart1.Axes.Left.Items.Clear;

  Chart1.Axes.LEFT.Minimum := -999999;                                            // 2010-10-11
  Chart1.Axes.LEFT.Maximum := 999999;                                             // 2010-10-11

  if (HI<>-999999) AND (Lo<>9999999) then                                        // 2014-08-05  //2016-04-20  HI WAS 0
    BEGIN
      if HI<Chart1.Axes.LEFT.MAXimum then                                       //2016-04-25  BEGIN
       BEGIN
          if HI<0 then             //WAS 1
              Chart1.Axes.LEFT.Maximum:=HI-(HI*0.1)
          ELSE
              Chart1.Axes.LEFT.Maximum:=(HI*1.1);
       END;
      if lo>Chart1.Axes.LEFT.Minimum then
        BEGIN
         if LO<0 then          //WAS 1
             Chart1.Axes.LEFT.Minimum:=lo+(LO*0.1)
         ELSE
             Chart1.Axes.LEFT.Minimum:=lo-(LO*0.1);
        END;                                                                    //2016-04-25  END

      if (hi-lo)<1 then                                                             //2014-08-01
        BEGIN
          Chart1.Axes.LEFT.Maximum := ( HI + ( (HI-lo)* 1.25 ) );
          Chart1.Axes.LEFT.Minimum := ( LO - ( 1.25 * (HI-LO) ) );
        END;
    END;

  If ( lMean > 0 ) And ( lStd > 0 ) Then
    begin
      TY:=lMean - ( 3.25 * lStd );                                               //2015-01-29
      if TY>Chart1.Axes.LEFT.Maximum THEN Chart1.Axes.LEFT.Maximum:=TY;          //2015-01-29

      Chart1.Axes.LEFT.Minimum := ( lMean - ( 3.25 * lStd ) );                     //2014-11-20  MOVED BEFORE MAX SET
      Chart1.Axes.LEFT.Maximum := ( lMean + ( 3.25 * lStd ) );                  // 2010-10-05
      If ( Hi > ( lMean + ( 3.25 * lStd ) ) ) Then
        Chart1.Axes.LEFT.Maximum := ( gHi + ( 0.5 * lStd ) );                   // 2010-10-05
      If ( Lo < ( lMean - ( 3.25 * lStd ) ) ) Then
        Chart1.Axes.LEFT.Minimum := ( gLo - ( 0.5 * lStd ) );
    end;
  Chart1.Axes.LEFT.Items.Add(Mean,'Mean');
      Chart1.Axes.LEFT.Items.Add((Mean+Std),'+1 STD');
      Chart1.Axes.LEFT.Items.Add((Mean+(2*Std)),'+2 STD');
      Chart1.Axes.LEFT.Items.Add((Mean+(3*Std)),'+3 STD');
  Series1.VertAxis := aBothVertAxis;
//  SHOWMESSAGE('AXIS:' + VARTOSTR(SERIES1.AssociatedToAxis(chart1.Axes.right)));

  Chart1.axes.RIGHT.Items.Clear;
  Chart1.axes.RIGHT.Maximum        := 99999;                                    // 2010-10-11
  Chart1.axes.RIGHT.Minimum        := -99999;                                   // 2010-10-11
  Chart1.axes.RIGHT.Minimum        := Chart1.Axes.LEFT.Minimum;                 // 2010-10-01
  Chart1.axes.RIGHT.Maximum        := Chart1.Axes.LEFT.Maximum;                 // 2010-10-01
  Chart1.axes.RIGHT.Visible        := True;
  Chart1.axes.RIGHT.ZPosition      := 100;
  Chart1.axes.RIGHT.Grid.ZPosition := 100;

  If ( lMean > 0 ) And ( lStd > 0 ) Then
    begin
      Chart1.axes.RIGHT.Maximum := Chart1.Axes.LEFT.Maximum;                    // 2010-10-05
      Chart1.axes.RIGHT.Minimum := Chart1.Axes.LEFT.Minimum;
    end;
  x := Chart1.axes.RIGHT.Minimum + ( lSTD * 0.25 );

  if X>Chart1.axes.RIGHT.Maximum then Chart1.axes.RIGHT.Maximum:=X;             // 2010-09-27

  While X < Chart1.axes.RIGHT.Maximum Do
    begin
      Chart1.axes.RIGHT.Items.Add(x);
      x := x + ( ( Chart1.axes.RIGHT.Maximum - Chart1.axes.RIGHT.Minimum ) / 15 );
    end;
  Screen.Cursor := crDefault;

end;

end.
